"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing_extensions import Annotated, TypedDict


class MorphoMarketPositionChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


class MorphoMarketPositionRequestTypedDict(TypedDict):
    chain: MorphoMarketPositionChain
    user_address: str
    r"""The user address of the desired market position."""
    unique_market_key: str
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""


class MorphoMarketPositionRequest(BaseModel):
    chain: Annotated[
        MorphoMarketPositionChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = MorphoMarketPositionChain.BASE_MAINNET

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x81d310Eb515E05EB26322e2DeDE9e75b754885A4"
    r"""The user address of the desired market position."""

    unique_market_key: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x3b3769cfca57be2eaed03fcc5299c25691b77781a1e124e7a8d520eb9a7eabb5"
    r"""The key that uniquely identifies the market. This can be found using the 'Get Markets' endpoint."""
